Attribute VB_Name = "Subroutines"
Option Explicit


Public Function ExtractFilePath(FileName As String) As String
    Dim C As Integer
    Dim I As Integer
    Dim Char As String

    For I = Len(FileName) To 1 Step -1
        Char = Mid$(FileName, I, 1)
        If (Char = "\") Or (Char = ":") Then Exit For
    Next I
    
    ExtractFilePath = Left$(FileName, I - C)
End Function

Public Function ExtractFileName(FileName As String) As String
    Dim I As Integer
    Dim Char As String
    Dim TempName As String
    
    For I = Len(FileName) To 1 Step -1
        Char = Mid$(FileName, I, 1)
        If (Char = "\") Or (Char = ":") Then Exit For
    Next I
    
    TempName = Mid$(FileName, I + 1)
    If (InStr(TempName, ".") = 0) Then TempName = ""
    
    ExtractFileName = TempName
End Function

Public Sub PopulateBackupDriveList(ComboCtl As ComboBox)
    Dim I As Integer
    
    ComboCtl.Clear
    
    For I = Asc("A") To Asc("Z")
        If (GetDriveType(Chr$(I) & ":\") = DRIVE_REMOVABLE) Then
            ComboCtl.AddItem Chr$(I) & ":"
        End If
    Next I
    
    If (ComboCtl.ListCount > 0) Then ComboCtl.ListIndex = 0
End Sub


